<ui:composition xmlns:rich="http://richfaces.org/rich" xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <ui:decorate template="/messages/transactionInstanceDisplay.xhtml">
            <ui:param name="managedBean" value="#{hl7MessageBrowser}"></ui:param>
            <ui:define name="requestContent">

                <h:panelGroup rendered="#{hl7MessageBrowser.isFhir()}">
                    <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                        <ui:param name="panel_id" value="requestGet"/>
                        <ui:param name="openByDefault" value="true"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.RequestGET']}</ui:define>
                        <a href="#{hl7MessageBrowser.getGetRequest(hl7MessageBrowser.selectedInstance.request)}">
                            <h:outputText
                                    value="#{hl7MessageBrowser.getGetRequest(hl7MessageBrowser.selectedInstance.request)}"/>
                        </a>
                        <br/>
                        <h:outputText value="#{messages['gazelle.HL7Common.URLHasBeenDecodedForEasyReading']}" styleClass="help-block"/>
                    </ui:decorate>
                </h:panelGroup>


                <h:panelGroup rendered="#{not hl7MessageBrowser.isFhir()}">
                    <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                        <ui:param name="panel_id" value="requestXml"/>
                        <ui:param name="openByDefault" value="#{hl7MessageBrowser.isHL7v3()}"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLMessageContent']}</ui:define>
                        <gdk:insert
                                content="#{hl7MessageBrowser.displayFormattedXML(hl7MessageBrowser.selectedInstance.request)}"
                                highlight="xml" encoding="UTF-8"/>
                    </ui:decorate>

                    <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                        <ui:param name="panel_id" value="requestSoapXml"/>
                        <ui:param name="openByDefault" value="#{hl7MessageBrowser.isHL7v3()}"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLPayloadMessageContent']}</ui:define>
                        <gdk:insert
                                content="#{hl7MessageBrowser.displayFormattedXMLPayload(hl7MessageBrowser.selectedInstance.request.getPayload())}"
                                highlight="xml" encoding="UTF-8"/>
                    </ui:decorate>

                    <s:decorate template="/layout/panels/_panel_collapse.xhtml"
                                rendered="#{hl7MessageBrowser.isHL7v2()}">
                        <ui:param name="panel_id" value="#{messages['gazelle.hl7.RequestTree']}"/>
                        <ui:param name="openByDefault" value="false"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLTreeMessageContent']}</ui:define>
                        <rich:tree switchType="client"
                                   value="#{hl7MessageBrowser.getTree(hl7MessageBrowser.selectedInstance.request)}"
                                   var="node" style="overflow: auto;background-color:white;">
                            <rich:treeNode>
                                <h:outputText value="#{node.data.name}: #{node.data.text}"/>
                            </rich:treeNode>
                        </rich:tree>
                    </s:decorate>
                    <s:decorate template="/layout/panels/_panel_collapse.xhtml"
                                rendered="#{hl7MessageBrowser.isHL7v2()}">
                        <ui:param name="panel_id" value="requestHighlight"/>
                        <ui:param name="openByDefault" value="#{hl7MessageBrowser.isHL7v2()}"/>
                        <ui:define name="panel_title">#{messages['gazelle.hl7.HighlightedER7']}</ui:define>
                        <h:outputText escape="false"
                                      value="#{hl7MessageBrowser.displayFormattedHTML(hl7MessageBrowser.selectedInstance.request)}"/>
                    </s:decorate>
                    <s:decorate template="/layout/panels/_panel_collapse.xhtml"
                                rendered="#{hl7MessageBrowser.isHL7v2()}">
                        <ui:param name="panel_id" value="requestRaw"/>
                        <ui:param name="openByDefault" value="false"/>
                        <ui:define name="panel_title">#{messages['gazelle.hl7.RawER7']}</ui:define>
                        <h:outputText
                                value="#{hl7MessageBrowser.getRawMessage(hl7MessageBrowser.selectedInstance.request)}"
                                escape="false"/>
                    </s:decorate>
                </h:panelGroup>
            </ui:define>
            <ui:define name="responseContent">

                <h:panelGroup rendered="#{hl7MessageBrowser.isFhir()}">
                    <s:div rendered="#{hl7MessageBrowser.selectedInstance.response.content != null}">
                        <s:decorate template="/layout/panels/_panel_title.xhtml"
                                    rendered="#{hl7MessageBrowser.isFhirXml()}">
                            <ui:param name="panel_id" value="responseXML"/>
                            <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLContent']}</ui:define>
                            <gdk:insert
                                    content="#{hl7MessageBrowser.displayFormattedXML(hl7MessageBrowser.selectedInstance.response)}"
                                    highlight="xml" encoding="UTF-8"/>
                        </s:decorate>
                        <s:decorate template="/layout/panels/_panel_title.xhtml"
                                    rendered="#{hl7MessageBrowser.isFhirJson()}">
                            <ui:param name="panel_id" value="responseJSON"/>
                            <ui:define name="panel_title">#{messages['gazelle.HL7Common.JSONContent']}</ui:define>
                            <pre>
                            <h:outputText
                                    value="#{hl7MessageBrowser.displayFormattedJSON(hl7MessageBrowser.selectedInstance.response)}"
                                    escape="false"/>
                        </pre>
                        </s:decorate>
                    </s:div>

                    <s:div rendered="#{hl7MessageBrowser.selectedInstance.response.payload != null}">
                        <s:decorate template="/layout/panels/_panel_title.xhtml"
                                    rendered="#{hl7MessageBrowser.isFhirXml()}">
                            <ui:param name="panel_id" value="responseSoapXML"/>
                            <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLContent']}</ui:define>
                            <gdk:insert
                                    content="#{hl7MessageBrowser.displayFormattedXMLPayload(hl7MessageBrowser.selectedInstance.response.getPayload())}"
                                    highlight="xml" encoding="UTF-8"/>
                        </s:decorate>
                        <s:decorate template="/layout/panels/_panel_title.xhtml"
                                    rendered="#{hl7MessageBrowser.isFhirJson()}">
                            <ui:param name="panel_id" value="responseSoapJSON"/>
                            <ui:define name="panel_title">#{messages['gazelle.HL7Common.JSONContent']}</ui:define>
                            <pre>
                            <h:outputText
                                    value="#{hl7MessageBrowser.displayFormattedJSONPayload(hl7MessageBrowser.selectedInstance.response.getPayload())}"
                                    escape="false"/>
                        </pre>
                        </s:decorate>
                    </s:div>

                    <s:div rendered="#{hl7MessageBrowser.selectedInstance.response.content == null}">
                        <rich:panel styleClass="gzl-alert gzl-alert-red">
                            <h:outputText value="#{messages['gazelle.HL7Common.NoPayloadReceived']}"/>
                        </rich:panel>
                    </s:div>
                </h:panelGroup>


                <h:panelGroup rendered="#{not hl7MessageBrowser.isFhir()}">
                    <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                        <ui:param name="panel_id" value="responseXML"/>
                        <ui:param name="openByDefault" value="#{hl7MessageBrowser.isHL7v3()}"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLMessageContent']}</ui:define>
                        <gdk:insert
                                content="#{hl7MessageBrowser.displayFormattedXML(hl7MessageBrowser.selectedInstance.response)}"
                                highlight="xml" encoding="UTF-8"/>
                    </ui:decorate>
                    <ui:decorate template="/layout/panels/_panel_collapse.xhtml">
                        <ui:param name="panel_id" value="responseSoapXML"/>
                        <ui:param name="openByDefault" value="#{hl7MessageBrowser.isHL7v3()}"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLPayloadMessageContent']}</ui:define>
                        <gdk:insert
                                content="#{hl7MessageBrowser.displayFormattedXMLPayload(hl7MessageBrowser.selectedInstance.response.getPayload())}"
                                highlight="xml" encoding="UTF-8"/>
                    </ui:decorate>

                    <s:decorate template="/layout/panels/_panel_collapse.xhtml"
                                rendered="#{hl7MessageBrowser.isHL7v2()}">
                        <ui:param name="panel_id" value="responseTree"/>
                        <ui:param name="openByDefault" value="false"/>
                        <ui:define name="panel_title">#{messages['gazelle.HL7Common.XMLTreeMessageContent']}</ui:define>
                        <rich:tree switchType="client"
                                   value="#{hl7MessageBrowser.getTree(hl7MessageBrowser.selectedInstance.response)}"
                                   var="node" style="overflow: auto;background-color:white;">
                            <rich:treeNode>
                                <h:outputText value="#{node.data.name}: #{node.data.text}"/>
                            </rich:treeNode>
                        </rich:tree>
                    </s:decorate>
                    <s:decorate template="/layout/panels/_panel_collapse.xhtml"
                                rendered="#{hl7MessageBrowser.isHL7v2()}">
                        <ui:param name="panel_id" value="responseHighlight"/>
                        <ui:param name="openByDefault" value="#{hl7MessageBrowser.isHL7v2()}"/>
                        <ui:define name="panel_title">#{messages['gazelle.hl7.HighlightedER7']}</ui:define>
                        <h:outputText escape="false"
                                      value="#{hl7MessageBrowser.displayFormattedHTML(hl7MessageBrowser.selectedInstance.response)}"/>
                    </s:decorate>
                    <s:decorate template="/layout/panels/_panel_collapse.xhtml"
                                rendered="#{hl7MessageBrowser.isHL7v2()}">
                        <ui:param name="panel_id" value="responseRaw"/>
                        <ui:param name="openByDefault" value="false"/>
                        <ui:define name="panel_title">#{messages['gazelle.hl7.RawER7']}</ui:define>
                        <h:outputText
                                value="#{hl7MessageBrowser.getRawMessage(hl7MessageBrowser.selectedInstance.response)}"
                                escape="false"/>
                    </s:decorate>
                </h:panelGroup>
            </ui:define>
        </ui:decorate>
    </ui:define>
</ui:composition>
